package uebung04;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.PasswordField;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;
import javafx.scene.text.Text;
import javafx.stage.Stage;


/**
 * 
 * Beispiel-Anwendung zu JavaFX vom Javakurs für Fortgeschrittene
 *
 * ES baut sich bei erfolgreichem Login ein zweites Fenster auf, welches die Bank-Anwendung
 * aus der letzten Stunde integriert.
 *
 */

public class BankGUI extends Application {
	
	@Override
	public void start(Stage primaryStage) {
		
	
		// Text-Feld für Status-Nachrichten
		final Text msg = new Text();
		
		// ID wird gesetzt für CSS
		msg.setId("msg-text");
		
		try {
			primaryStage.setTitle("Willkommen");
			
			// Alles in eine GridPane, die zentral ausgerichtet ist:
			GridPane gp = new GridPane();	
			gp.setHgap(10);
			gp.setVgap(10);
			gp.setAlignment(Pos.CENTER);
			gp.setPadding(new Insets(25));
			
			// Die Szene für den Login-Screen
			Scene scene = new Scene(gp);
			
			// Die Szene auf die Bühne holen
			primaryStage.setScene(scene);
			
			// Überschrift, Labels und Textfelder generieren:
			Text t_welcome = new Text("Willkommen bei Ihrer Bank!");
			t_welcome.setId("ueberschrift");
			
			Label l_user = new Label("Nutzername: ");
			Label l_pswd = new Label("Passwort: ");
			
			TextField tf_user = new TextField();
			PasswordField tf_pswd = new PasswordField();

			// Alle Elemente ins Grip packen
			gp.add(t_welcome, 0, 0, 2, 1);
			gp.add(l_user,0,1);
			gp.add(tf_user, 1, 1);
			gp.add(l_pswd, 0, 2);
			gp.add(tf_pswd,1,2);
			gp.add(msg, 1, 4);
			
			// Den Button definieren:
			Button login_button = new Button("Einloggen");
			
			// Den Button einen Event Handler anheften (mittels anonymer innerer Klasse):
			login_button.setOnAction(new EventHandler<ActionEvent>() {
				
				@Override
				public void handle(ActionEvent event) {
					if(tf_user.getText().equals("")){
						msg.setText("Es wurde kein Nutzername eingegeben!");
					}
					
					else if(tf_pswd.getText().equals("")){
						msg.setText("Es wurde kein Passwort eingegeben!");
					}
					else{
						msg.setText("Nutzer eingeloggt!");
					}
					
				}
			});
			
			//Alternativ mit Lambda-Ausdruck - geht genau so nur etwas kürzer.
			// Zum Testen einfach den folgenden Code einkommentieren:
			/*
			login_button.setOnAction(e->{				
				if(tf_user.getText().equals("")){
					msg.setText("Es wurde kein Nutzername eingegeben!");
				}
				
				else if(tf_pswd.getText().equals("")){
					msg.setText("Es wurde kein Passwort eingegeben!");
				}
				else{
					//msg.setText("Nutzer eingeloggt!");
					primaryStage.setScene(new Scene(new BankScreen()));
					primaryStage.setTitle("Meine Transaktionen");
					primaryStage.sizeToScene();
				}				
			});
			*/

			// Button zum Grid hinzufügen
			gp.add(login_button, 1, 3);
			
			
			// Die Größe der Bühne auf die Größe der Szene mappen
			primaryStage.sizeToScene();
			
			// Und das Ganze anzeigen nicht vergessen!
			primaryStage.show();
			
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	// Main-Methode für die Ausführbarkeit ohne JavaFX Launcher
	public static void main(String[] args) {
		launch(args);
	}
}
